// TreeCtrlDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TreeCtrlDemo.h"
#include "TreeCtrlDemoDlg.h"

#include "about.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDemoDlg dialog

CTreeCtrlDemoDlg::CTreeCtrlDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTreeCtrlDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTreeCtrlDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTreeCtrlDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTreeCtrlDemoDlg)
	DDX_Control(pDX, IDC_TREE1, m_tree);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTreeCtrlDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CTreeCtrlDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(ID_APP_ABOUT, OnAbout)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
  ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
  ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDemoDlg message handlers

BOOL CTreeCtrlDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	HTREEITEM h1 = m_tree.InsertItem("CFile"); 
	HTREEITEM h2 = m_tree.InsertItem("CMemFile", h1); 
	m_tree.InsertItem("CSharedFile", h2); 
	
	HTREEITEM h3 = m_tree.InsertItem("COleStreamFile",h1); 
	HTREEITEM h4 = m_tree.InsertItem("CMonikerFile",h3); 
	HTREEITEM h5 = m_tree.InsertItem("CAsyncMonikerFile", h4); 
	HTREEITEM h6 = m_tree.InsertItem("CDataPathProperty", h5); 
	m_tree.InsertItem("CCachedDataPathProperty", h6); 

	m_tree.InsertItem("CSocketFile", h1); 

	HTREEITEM h7 = m_tree.InsertItem("CStdioFile", h1); 
	HTREEITEM h8 = m_tree.InsertItem("CInternetFile", h7); 
  m_tree.InsertItem("CGopherFile", h8); 
  m_tree.InsertItem("CHttpFile", h8); 

  ExpandAllBranches();
	
  return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTreeCtrlDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTreeCtrlDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTreeCtrlDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTreeCtrlDemoDlg::OnAbout()
{
 CAboutDlg().DoModal();
}

void CTreeCtrlDemoDlg::OnBnClickedButton2()
{
  CAboutDlg().DoModal();
}

void CTreeCtrlDemoDlg::ExpandBranch(HTREEITEM hItem, BOOL bExpand /*= TRUE*/)
{
  if (m_tree.ItemHasChildren(hItem))
  {
    m_tree.Expand(hItem, 
      bExpand ? TVE_EXPAND : TVE_COLLAPSE);
    hItem = m_tree.GetChildItem(hItem);
    do
    {
      ExpandBranch(hItem);
    } while ((hItem =
    m_tree.GetNextSiblingItem(hItem)) != NULL);
  }
}

void CTreeCtrlDemoDlg::ExpandAllBranches(BOOL bExpand /*= TRUE*/)
{
  HTREEITEM hItem = m_tree.GetRootItem();
  do
  {
    ExpandBranch(hItem, bExpand);
  } while ((hItem =
  m_tree.GetNextSiblingItem(hItem)) != NULL);

  m_tree.Select(hItem, TVGN_FIRSTVISIBLE);
}

void CTreeCtrlDemoDlg::OnBnClickedButton1()
{
  ExpandAllBranches();
}

void CTreeCtrlDemoDlg::OnBnClickedButton3()
{
  ExpandAllBranches(FALSE);
}
