// TreeMessagesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TreeMessages.h"
#include "TreeMessagesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTreeMessagesDlg dialog



CTreeMessagesDlg::CTreeMessagesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTreeMessagesDlg::IDD, pParent)
  , m_strTree1SelectedItem("")
  , m_strTree2SelectedItem("")
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTreeMessagesDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TREE1, m_treeDialogMessages);
  DDX_Text(pDX, IDC_EDIT1, m_strTree1SelectedItem);
  DDX_Control(pDX, IDC_TREE2, m_treeReflection);
}

BEGIN_MESSAGE_MAP(CTreeMessagesDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnTvnSelchangedTree1)
  ON_NOTIFY(TVN_SELCHANGED, IDC_TREE2, OnTvnSelchangedTree2)
END_MESSAGE_MAP()


// CTreeMessagesDlg message handlers

BOOL CTreeMessagesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  CString strItem;
	for (int i = 0; i < 5; i++)
	{
	  strItem.Format("Tree 1, Item %d", i + 1);
	  m_treeDialogMessages.InsertItem(strItem);
	}

  for (int i = 0; i < 5; i++)
  {
    strItem.Format("Tree 2, Item %d", i + 1);
    m_treeReflection.InsertItem(strItem);
  }

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTreeMessagesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTreeMessagesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTreeMessagesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTreeMessagesDlg::OnTvnSelchangedTree1(NMHDR *pNMHDR, LRESULT *pResult)
{
  LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
  
  // Get the selected item and its text value
  HTREEITEM ht = m_treeDialogMessages.GetSelectedItem();
  CString strSelection = m_treeDialogMessages.GetItemText(ht);
  
  // Update the dialogs edit control with the new value
  m_strTree1SelectedItem = strSelection;
  UpdateData(FALSE);
    
  *pResult = 0;
}

void CTreeMessagesDlg::OnTvnSelchangedTree2(NMHDR *pNMHDR, LRESULT *pResult)
{
  LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
  
  // Get the selected item and its text value
  HTREEITEM ht = m_treeReflection.GetSelectedItem();
  CString strSelection = m_treeReflection.GetItemText(ht);
  
  // Update the dialogs edit control with the new value
  m_strTree1SelectedItem = strSelection;
  UpdateData(FALSE);
    
  *pResult = 0;
}
